import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.text.*;
import java.util.*;
import java.util.prefs.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;

//-------------------------------------
public class IndxCrds extends JFrame implements WindowListener {

public class BytA extends ArrayList<Byte> {}
public class IntA extends ArrayList<Integer> {}
public class StringA extends ArrayList<String> {}
public class StringV extends Vector<String> {}

static IndxCrds mf;
static String   fto;

JButton       sbar;
JList<String> lbox;
JScrollPane   splb, spta;
JTextArea     txta;

boolean       nsav;
File          cfil, fil;
Font          lbf, taf, uif;
int           maxx, maxy, winx, winy;
int           sbh;
int           lbfs, tafs, uifs, wxp, wyp;
int           lbp, sidx;
IntA          fnda;
String        cdir, fnds, stxt, uifn, wdir;
StringA       crda, tita;

static final int  LBFSIZ = 24;
static final int  TAFSIZ = 20;
static final int  UIFSIZ = 32;
static final String LBFSLIT = "LBFS";
static final String LBPLIT  = "LBP";
static final String TAFSLIT = "TAFS";
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT = "WXP";
static final String WYPLIT = "WYP";

static final String DEFDIR  = "C:\\";
static final String DIRKEY  = "WRKDIR";
static final String APPNAM  = "IndexCards";

static final String DFS     = "yy/MM/dd";
static final String TFS     = "HH:mm:ss";
static final String DTFS    = "yy/MM/dd HH:mm:ss";

//-------------------------------------
class ACard implements ActionListener {
public void actionPerformed(ActionEvent cae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Add");
  mi.setMnemonic('A');
  mi.addActionListener(new ACardAdd());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Delete");
  mi.setMnemonic('D');
  mi.addActionListener(new ACardDelete());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("File");
  mi.setMnemonic('F');
  mi.addActionListener(new ACardFile());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Journal");
  mi.setMnemonic('J');
  mi.addActionListener(new ACardJournal());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class ACardAdd implements ActionListener {
public void actionPerformed(ActionEvent caae) {
int       idx;
String    s;
  if ((crda.size()>0) && nsav) SaveCurrentCard();
  s = "";
  crda.add(s);
  sidx = crda.size() - 1;
  LoadListBox();
  txta.requestFocusInWindow();
  txta.setEditable(true);
  txta.setCaretPosition(s.length());
  nsav = true;
}}

//-------------------------------------
class ACardDelete implements ActionListener {
public void actionPerformed(ActionEvent cdae) {
  crda.remove(sidx);
  if (sidx>=crda.size()) sidx = crda.size() - 1;
  LoadListBox();
  nsav = true;
}}

//-------------------------------------
class ACardFile implements ActionListener {
public void actionPerformed(ActionEvent caae) {
int          fsts;
JFileChooser fc;
String       s;
  if ((crda.size()>0) && nsav) SaveCurrentCard();
  fc = new JFileChooser(cdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    cfil = fc.getSelectedFile();
    cdir = cfil.getPath();
    s = Util.ReadTextFile(cfil, mf);
    crda.add(s);
    sidx = crda.size() - 1;
    txta.requestFocusInWindow();
    txta.setEditable(true);
    txta.setBackground(new Color(0xFFFFFF));
    txta.setCaretPosition(1);
    nsav = true;
    SortStringA(crda);
    LoadListBox();
  }
}}

//-------------------------------------
class ACardJournal implements ActionListener {
public void actionPerformed(ActionEvent caae) {
Date        dt;
DateFormat  df;
int         idx;
long        tim;
String      s;
  if ((crda.size()>0) && nsav) SaveCurrentCard();
  tim = System.currentTimeMillis();
  dt = new Date(tim);
  df = new SimpleDateFormat(DTFS);
  s = df.format(dt);
  s += "\n\n";
  crda.add(s);
  LoadListBox();
  idx = crda.size() - 1;
  lbox.setSelectedIndex(idx);
  txta.requestFocusInWindow();
  txta.setEditable(true);
  txta.setCaretPosition(s.length());
  nsav = true;
}}

//-------------------------------------
class AEdit implements ActionListener {
public void actionPerformed(ActionEvent fae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Copy");
  mi.setMnemonic('C');
  mi.addActionListener(new AEditCopy());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("cuT");
  mi.setMnemonic('T');
  mi.addActionListener(new AEditCut());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Paste");
  mi.setMnemonic('P');
  mi.addActionListener(new AEditPaste());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Select");
  mi.setMnemonic('S');
  mi.addActionListener(new AEditSelect());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}
//-------------------------------------
class AEditCopy implements ActionListener {
public void actionPerformed(ActionEvent fnae) {
  txta.copy();
}}
//-------------------------------------
class AEditCut implements ActionListener {
public void actionPerformed(ActionEvent fnae) {
  txta.cut();
}}
//-------------------------------------
class AEditPaste implements ActionListener {
public void actionPerformed(ActionEvent fnae) {
  txta.paste();
}}
//-------------------------------------
class AEditSelect implements ActionListener {
public void actionPerformed(ActionEvent fnae) {
  txta.selectAll();
}}

//-------------------------------------
class AFile implements ActionListener {
public void actionPerformed(ActionEvent fae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Open");
  mi.setMnemonic('O');
  mi.addActionListener(new AFileOpen());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Save");
  mi.setMnemonic('S');
  mi.addActionListener(new AFileSave());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("saveAs");
  mi.setMnemonic('A');
  mi.addActionListener(new AFileSaveAs());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("New");
  mi.setMnemonic('N');
  mi.addActionListener(new AFileNew());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AFileNew implements ActionListener {
public void actionPerformed(ActionEvent fnae) {
  if (nsav) CheckSave();
  fil = null;
  sidx = -1;
  txta.setText("");
  crda.clear();
  LoadListBox();
  nsav = false;
}}

//-------------------------------------
class AFileOpen implements ActionListener {
public void actionPerformed(ActionEvent foae) {
BytA            ba, tsa;
byte[]          bufr;
byte            byt;
int             fsts, i, j, nbyt, read;
FileInputStream fis;
JFileChooser    fc;
String          fn, fp, s;
String          line;
  if (nsav) CheckSave();
  fc = new JFileChooser(wdir);
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = fc.getSelectedFile();
    fn = fil.getName();
    fp = fil.getPath();
    wdir = fp;
    SetPreferences();
    crda.clear();
    mf.setTitle(fn);
    ba = new BytA();
    tsa = new BytA();
    bufr = new byte[0x1000];
    try {
      fis = new FileInputStream(fil);
      do {
        read = fis.read(bufr, 0, 0x1000);
        if (read!=-1) for (i=0; i<read; i++) ba.add(bufr[i]);
      } while(read!=-1);
    } catch (Exception x) { Util.DspMsg(x.toString(), mf); }
    nbyt = ba.size();
    i = 0;
    while (i<nbyt) {
      tsa.clear();
      do {
        byt = ba.get(i++);
        if (byt != 0) tsa.add(byt);
      } while (byt != 0);
      bufr = new byte[tsa.size()];
      for (j=0; j<tsa.size(); j++) bufr[j] = tsa.get(j);
      try {
        line = new String(bufr, "UTF-8");
        crda.add(line);
      } catch (Exception x) { Util.DspMsg(x.toString(), mf); }
    }
    if (crda.size()>0) sidx = 0;
    LoadListBox();
    nsav = false;
    txta.requestFocusInWindow();
  }
}}

//-------------------------------------
class AFileSave implements ActionListener {
public void actionPerformed(ActionEvent fsae) {
  if (nsav) SaveCurrentCard();
  if (fil==null) GetFileToSave();
  else SaveFile();
}}

//-------------------------------------
class AFileSaveAs implements ActionListener {
public void actionPerformed(ActionEvent fsaae) {
  if (nsav) SaveCurrentCard();
  GetFileToSave();
}}

//-------------------------------------
class AList implements ActionListener {
public void actionPerformed(ActionEvent qae) {
int       i, idx, ne;
String    s;
String[]  sa;
  if (nsav) SaveCurrentCard();
  ne = tita.size();
  sa = new String[ne];
  for (i=0; i<ne; i++) {
    s = tita.get(i);
    sa[i] = s;
  }
  idx = Util.GetListIndex("Select", sa, mf);
  if (idx==-1) return;
  sidx = idx;
  lbox.setSelectedIndex(idx);
  lbox.ensureIndexIsVisible(idx);
  SetCurrentCard();
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  if (nsav) {
    SaveCurrentCard();
    CheckSave();
  }
  System.exit(0);
}}

//-------------------------------------
class ASearch implements ActionListener {
public void actionPerformed(ActionEvent ae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Cards");
  mi.setMnemonic('C');
  mi.addActionListener(new ASearchCards());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Results");
  mi.setMnemonic('R');
  mi.addActionListener(new ASearchResults());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Find");
  mi.setMnemonic('F');
  mi.addActionListener(new ASearchFind());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Next");
  mi.setMnemonic('N');
  mi.addActionListener(new ASearchNext());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class ASearchCards implements ActionListener {
public void actionPerformed(ActionEvent ae) {
boolean   fnd;
int       i, j, nc, ns;
String    cs, ct, ss;
String[]  sa;
  ss = Util.GetStringValue("Strings", "", mf);
  if (ss==null) return;
  sa = ss.split(" ");
  ns = sa.length;
  nc = crda.size();
  fnda.clear();
  for (i=0; i<nc; i++) {
    ct = crda.get(i).toLowerCase();
    fnd = true;
    for (j=0; j<ns; j++) {
      cs = sa[j].toLowerCase();
      if (!ct.contains(cs)) fnd = false;
    }
    if (fnd) fnda.add(i);
  }
  ct = String.format("Found %d matches", fnda.size());
  Util.DspMsg(ct, uif, mf);
}}

//-------------------------------------
class ASearchFind implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  fnds = Util.GetStringValue("Find", "", mf);
  if (fnds==null) return;
  fnds = fnds.toLowerCase();
  SearchNext();
}}

//-------------------------------------
class ASearchNext implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  SearchNext();
}}

//-------------------------------------
class ASearchResults implements ActionListener {
public void actionPerformed(ActionEvent ae) {
int       i, nr, res;
String[]	sa;
  nr = fnda.size();
  sa = new String[nr];
  for (i=0; i<nr; i++) sa[i] = tita.get(fnda.get(i));
  res = -1;
  res = Util.GetListIndex("Select", sa, mf);
  if (res!=-1) {
    if (nsav) SaveCurrentCard();
    sidx = fnda.get(res);
    lbox.setSelectedIndex(sidx);
  }
}}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent cbae) {
  PopupMain();
}}

//-------------------------------------
class CBClick extends MouseAdapter {
public void mouseClicked(MouseEvent me) {
   PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
}}

//-------------------------------------
class CBModified implements DocumentListener {
  public void insertUpdate(DocumentEvent e) { nsav = true; }
  public void removeUpdate(DocumentEvent e) { nsav = true; }
  public void changedUpdate(DocumentEvent e) { nsav = true; }
}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
Dimension dim;
Insets    is;
  sbh = sbar.getHeight();
  winx = getWidth();
  winy = getHeight();
  is = mf.getInsets();
  winx -= (is.left+is.right);
  winy -= (is.top+is.bottom);
  dim = new Dimension((winx*lbp)/100, winy-sbh);
  splb.setPreferredSize(dim);
}}

//-------------------------------------
class CBSelection implements ListSelectionListener {
public void valueChanged(ListSelectionEvent e) {
int     idx;
String  crd;
  if (nsav) SaveCurrentCard();
  idx = lbox.getSelectedIndex();
  if (idx==-1) return;
  sidx = idx;
  SetCurrentCard();
}}

//-------------------------------------
void CheckSave() {
int   rv;
  rv = JOptionPane.showConfirmDialog(null,"Save File?","File Changed",JOptionPane.YES_NO_OPTION);
  if (rv==JOptionPane.YES_OPTION) {
    SaveCurrentCard();
    if (fil==null) GetFileToSave();
    else SaveFile();
  }
}

//-------------------------------------
void GetFileToSave() {
int           fsts;
JFileChooser  fc;
  fc = new JFileChooser();
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = fc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = fc.getSelectedFile();
    SaveFile();
  }
}

//-------------------------------------
public IndxCrds(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
  if (args.length>0) fto = args[0];
  else fto = "";
}

//-------------------------------------
public void Initlz() {
  InitlzVars();
  ReadIniFile();
  ReadPreferences();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
void InitlzUI() {
  winx = (wxp*maxx)/100;
  winy = (wyp*maxy)/100;
  lbf = new Font(Font.SERIF, Font.BOLD, lbfs);
  uif = new Font(uifn, Font.BOLD, uifs);
  taf = new Font(Font.MONOSPACED, Font.BOLD, tafs);
  Util.PutUIManFonts(taf);
  InitlzUIListBox();
  InitlzUIResources();
  InitlzUIStatusBar();
  InitlzUITextArea();
}

//-------------------------------------
void InitlzUIListBox() {
Dimension   dim;
JScrollBar  jsb;
  lbox = new JList<String>();
  lbox.addKeyListener(new CBKey());
  lbox.setFont(lbf);
  lbox.setBackground(new Color(0xFFFFFF));
  lbox.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  lbox.addListSelectionListener(new CBSelection());
  splb = new JScrollPane(lbox);
  splb.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  splb.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = splb.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=2;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzUIResources() {
Image       iimg;
Toolkit     tk;
URL         iurl;
  tk = Toolkit.getDefaultToolkit();
  iurl = mf.getClass().getResource("/IndxCrds.png");
  iimg = tk.createImage(iurl);
  setIconImage(iimg);
}

//-------------------------------------
void InitlzUIStatusBar() {
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
}

//-------------------------------------
void InitlzUITextArea() {
Dimension   dim;
JScrollBar  jsb;
  txta = new JTextArea();
  txta.addKeyListener(new CBKey());
  txta.setFont(taf);
  txta.setBackground(new Color(0xC0FFC0));
  txta.setLineWrap(true);
  txta.setWrapStyleWord(true);
  txta.getDocument().addDocumentListener(new CBModified());
  txta.setEditable(false);
  spta = new JScrollPane(txta);
  spta.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  spta.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = spta.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=2;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzVars() {
  lbfs = LBFSIZ;
  uifs = UIFSIZ;
  tafs = TAFSIZ;
  sbh = UIFSIZ;
  wxp = 80;
  wyp = 80;
  lbp = 30;
  nsav = false;
  wdir = DEFDIR;
  cdir = wdir;
  sidx = -1;
  fil = null;
  cfil = null;
  uifn = "FreeMono";
  crda = new StringA();
  tita = new StringA();
  fnda = new IntA();
  stxt = "Click Here";
}

//-------------------------------------
void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.addComponentListener(new CBResize());
  mf.setLocation(0, 0);
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(splb, BorderLayout.EAST);
  mf.getContentPane().add(spta, BorderLayout.CENTER);
  mf.setTitle("IndxCrds");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
void LoadListBox() {
int       i, ncrd;
StringV   ct;
String    lin, title;
String[]  tsa;
  ncrd = crda.size();
  ct = new StringV();
  tita.clear();
  for (i=0; i<ncrd; i++) {
    title="";
    lin = crda.get(i);
    tsa = lin.split("\n");
    if (tsa.length>0) title = tsa[0];
    ct.add(title);
    tita.add(title);
  }
  lbox.setListData(ct);
  if (sidx!=-1) lbox.setSelectedIndex(sidx);
  if (fil==null) lin = String.format("#Cards %d", ncrd);
  else lin = String.format("%s #Cards %d", fil.getName(), ncrd);
  sbar.setText(lin);
}

//-------------------------------------
public static void main(String[] args) {
  mf = new IndxCrds(args);
  mf.Initlz();
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("File");
  mi.setMnemonic('F');
  mi.addActionListener(new AFile());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Card");
  mi.setMnemonic('C');
  mi.addActionListener(new ACard());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Edit");
  mi.setMnemonic('E');
  mi.addActionListener(new AEdit());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Search");
  mi.setMnemonic('S');
  mi.addActionListener(new ASearch());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("List");
  mi.setMnemonic('L');
  mi.addActionListener(new AList());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"IndxCrds.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(LBFSLIT)==0) lbfs = Integer.parseInt(val);
        if (nam.compareTo(LBPLIT)==0) lbp = Integer.parseInt(val);
        if (nam.compareTo(TAFSLIT)==0) tafs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (IOException x) { System.err.format("IOException: %s%n", x); }
}

//-------------------------------------
void ReadPreferences() {
Preferences p;
  try {
    p = Preferences.userRoot().node(getClass().getName());
    wdir = p.get(DIRKEY, DEFDIR);
  } catch (Exception x) { Util.DspMsg(x.toString(), mf); }
}

//-------------------------------------
void SaveCurrentCard() {
String  crd;
  crd = txta.getText();
  crda.set(sidx, crd);
}

//-------------------------------------
void SaveFile() {
byte[]            ba;
FileOutputStream  fos;
int               i, j, ncrd;
String            s;
  SortStringA(crda);
  try {
    fos = new FileOutputStream(fil);
    ncrd = crda.size();
    try {
      for (i=0; i<ncrd; i++) {
        s = crda.get(i);
        ba = s.getBytes();
        fos.write(ba);
        fos.write(0);
      }
      fos.close();
    } catch (IOException x) { Util.DspMsg(x.toString(), mf); }
  } catch (FileNotFoundException x) { Util.DspMsg(x.toString(), mf); }
  LoadListBox();
  nsav = false;
}

//-------------------------------------
void SearchNext() {
int     from, pos, ss, se;
String  fc;
  fc = txta.getText();
  fc = fc.toLowerCase();
  from = txta.getCaretPosition();
  pos = fc.indexOf(fnds, from);
  if (pos==-1) {
    Util.DspMsg("No Matches", uif, mf);
    return;
  }
  txta.setCaretPosition(pos);
  ss = pos;
  se = pos + fnds.length();
  txta.select(ss,se);
}

//-------------------------------------
void SetCurrentCard() {
boolean sts;
String  crd;
  sts = nsav;
  crd = crda.get(sidx);
  txta.setText(crd);
  txta.setCaretPosition(0);
  txta.setEditable(true);
  txta.setBackground(new Color(0xFFFFFF));
  nsav = sts;
}

//-------------------------------------
void SetPreferences() {
Preferences p;
  p = Preferences.userRoot().node(getClass().getName());
  p.put(DIRKEY, wdir);
}

//-------------------------------------
void SortStringA(StringA sa) {
boolean swapped;
String  s1, s2;
int     i, asiz;
  asiz = sa.size();
  do {
    swapped = false;
    for (i = 0; i < (asiz-1); i++) {
      s1 = sa.get(i);
      s2 = sa.get(i+1);
      if (s1.compareTo(s2)>0) {
        sa.set(i, s2);
        sa.set(i+1, s1);
        swapped = true;
      }
    }
  } while (swapped);
}

//-------------------------------------
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowClosing(WindowEvent e) { if (nsav) CheckSave(); }
public void windowClosed(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}

//-------------------------------------
}
